// OO.C		Orcs & 'oles.
// ---------------------------------------------
#include <time.h>
#include <stdlib.h>
#include <funky.h>
#include <stdio.h>
#include <funky.h>
#include <conio.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>
#pragma hdrstop

// DEFINES ------------------------------------------------

#define MAXADJ	12
#define MAXCBT	11
#define CR	cputs("\n\r") ;


// General Variables --------------------------------------

int quit=0 ;

char * monfile = "MONSTER.OO" ;

char * gemname[7] = { "Garnet", "Opal", "Pearl", "Amethyst", "Sapphire","Emerald", "Diamond" } ;

int nmon ;	// number of monsters
int mhp, mxhp ;	// monster hp, maxhp ;
struct mon { char name[21] ; int hp, spd, ct, mt, flag ; } * MonTable ;
// flag: 0 = wpn, 1 = regen

struct room { int wall, key, contain, mon, adj, mhp, mxhp ; } Room[3] ;
// room.contain: bit 0 = Monster, 1 = Treasure

char * RoomName[8] = { "Blank Wall", "Passage", "Stairs Up", "Stairs Down", "Door", "Portal", "Cavern", "Cave" } ;

char * AdjList[MAXADJ] = { " fat", "n angry", " huge", "n ugly", " growling", "n evil", " Belgian", " large", " scrawny", " giant", " small", " baby" } ;
int AdjSize[MAXADJ] = { 50, 60, 80, 50, 55, 45, 40, 65, 30, 100, 35, 15 } ;	// average 50

char * CbtText[MAXCBT] = { "BAF", "Thud", "wop", "WHAM", "biff", "Bong", "**!*-!**!", "SPLAT", "CRACK", "oof", "Crunch" } ;

// PC Variables -------------------------------------------

int hp, key, lvl, spell, fball, arrow, gems[7], pots, killed ;
long pp, gp, sp, cp ;

// BITS ---------------------------------------------------

int dran(int n)
{
	return random(n)+random(n) ;
}

void Title()
{
	textattr(0xF) ;
	clrscr() ;
	gotoxy(25,1) ;
	cprintf("- - O R C S   n   ' O L E S - -\n\r") ;
	textattr(7) ;
}

void ShowStats()
{
	int i, n ;
	long sc ;
	textattr(10) ;
	CR ; CR ;
	for(i=n=0;i<16;i++)
	  n+=(key>>i)&1 ;
	cprintf("Level:      %-3d\n\r", lvl) ;
	cprintf("Hit Points: %-3d        Spells:     %-3d        Fireballs:  %-3d\n\r", hp, spell, fball) ;
	cprintf("Arrows:     %-3d        Potions:    %-3d        Keys:       %-3d\n\n\r", arrow, pots, n) ;

	sc=n*10+hp+spell*10+fball*20+arrow*5+pots*10+killed*5-lvl*50 ;

	for(i=6;i>=0;i--)
	  if(gems[i])
	  { cprintf("%d %s%s, ",gems[i],gemname[i],gems[i]>1?"s":"") ;
	    sc+=2*(i+1)*(i+1)*gems[i] ;
	  }
	cprintf("%ld pp, %ld gp, %ld sp and %ld cp\n\r",pp, gp, sp, cp) ;
	sc+=pp/5+gp/50+sp/500+cp/5000 ;
	cprintf("You have killed %d monsters; your score is %ld\n\r", killed, sc) ;
	textattr(7) ;
}

void Help(int n)
{
	textattr(15) ;
	cprintf("HELP\n\n\r") ;
	cprintf("Context is %d",n) ;
	textattr(7) ;
}

// INITIALISATION -----------------------------------------

int AskFile()
{
	return 1 ;
}

void NewPC()
{
	int i, n ;
	randomize() ;
	hp=100 ;
	spell=10 ;
	fball=1 ;
	arrow=10 ;
	lvl=10 ;
	key=pp=gp=sp=cp=0 ;
	for(n=0;n<7;n++)
	  gems[n]=0 ;
}

int LoadMonsters()	// return 1 if OK
{
	FILE *h ;
	struct mon * ptr ;
	int n, i ;
	char c ;
	if((h = fopen(monfile,"rt"))== NULL)
	  return 0 ;

	fscanf(h,"%d",&nmon) ;
	ptr=MonTable=(struct mon*)malloc(nmon*sizeof(struct mon)) ;

	for(n=0;n<nmon;n++)
	{ for(i=0;i<20;)
	  { c=fgetc(h) ;
	    if(c=='.')
	    { ptr->name[i]=0 ;
	      i=99 ;
	    }
	    else
	      if(c>31)		// avoid the carriage returns etc
		ptr->name[i++]=c ;
	  }
	  fscanf(h,"%d %d %d %d %d", &ptr->hp, &ptr->spd, &ptr->ct, &ptr->mt, &ptr->flag) ;
	  ptr++ ;
	}

	fclose(h) ;
	return 1 ;
}

int Init()
{
	int n=1 ;
	directvideo=1 ;
	textmode(C80) ;
	Title() ;
	n=AskFile() ;
	if(n==1)
	{ NewPC() ;
	}
	if(n)
	{ if(!LoadMonsters())
	  { textattr(12) ;
	    clrscr() ;
	    cprintf("Monster file %s missing. Program aborted.\r\n",monfile) ;
	    n=0 ;
	  }
	}
	return n ;
}

// POTIONS ------------------------------------------------

void Drink()
{
	int i ;
	CR ;
	if(pots)
	{ pots-- ;
	  for(i=0;i<8;i++)
	  { cputs("Glug  ") ;
	    delay(300) ;
	  }
	  CR ;
	  switch(random(6))
	  { case 0:
	    case 1:	cputs("You are healed!\n\r") ;
			hp+=10+dran(10) ;
			break ;
	    case 2:	cputs("You are strengthened!\n\r") ;
			hp+=15+dran(20) ;
			break ;
	    case 3:	cputs("It is poison!\n\r") ;
			hp-=5+dran(10) ;
			break ;
	    case 4:	cputs("You are imbued with magical power!\n\r") ;
			spell+=1+dran(4) ;
			break ;
	    case 5:	cputs("It is mere water...\n\r") ;
			if(hp<100)
			  hp+=(110-hp)/10 ;
			break ;
	  }
	}
	else
	  cputs("You have no potions.\n\r") ;
}

// COMBAT -------------------------------------------------

void BlastCbt(int m)
{
	if(spell)
	{ spell-- ;
	  cprintf("BLAM!!!   You blast the evil %s.\n\r", MonTable[m].name) ;
	  mhp-=dran(7)+3 ;
	}
	else
	  cputs("You have no spells.\n\r") ;
}

void FireCbt(int m)
{
	if(fball)
	{ fball-- ;
	  cprintf("KaThoom!!!!   The foul %s is engulfed in flame!\n\r", MonTable[m].name) ;
	  mhp-=dran(15)+10 ;
	}
	else
	  cputs("You have no fireballs.\n\r") ;
}

void ArrowCbt()
{
	if(arrow)
	{ arrow-- ;
	  cputs("Twang...") ; delay(600) ;
	  if(random(hp*2+150)>random(mhp+200))
	  { cputs("You hit!\n\r") ;
	    mhp-=dran(10) ;
	  }
	  else
	    cputs("Missed.\n\r") ;
	}
	else
	  cputs("You have no arrows.\n\r") ;
}

void Cbt(int m, int a)	// a is the monster's advantage: 0 to 2
{
	int t=mhp/3, i=random(2*mhp/(3-a))+1 ;
	mhp-=random(2*hp/(2+a))+1 ;
	hp-=i ;
	CR ;
	for(i=0;i<t;i++)
	{ cputs(CbtText[random(MAXCBT)]) ;
	  putch(' ') ;
	  delay(200) ;
	}
	cprintf("\n\rYou have a terrific fight with the %s!\n\r",MonTable[m].name) ;
}

void KickCbt(int m)
{
	if(random(hp)>random(mhp*10))
	{ cprintf("Wham!   You hoof the puny %s in the head, breaking its neck!\n\r", MonTable[m].name) ;
	  mhp=0 ;
	}
	else
	{ cprintf("Bonk.   You kick the %s. It is not pleased and leaps on you!\n\r", MonTable[m].name) ;
	  Cbt(m,2) ;
	}
}

int RunCbt(int m)
{
	int s, ret=0 ;
	cputs("You leg it...") ; delay(600) ;
	s=MonTable[m].spd*mhp/MonTable[m].hp ;
	if(random(s)>random(hp))
	{ cputs("but it catches you!\n\r") ;
	  Cbt(m,1) ;
	}
	else
	{ cputs("and escape!\n\r") ;
	  ret=1 ;
	}
	return ret ;
}

int Combat(int m)	// return 1 if kill the monster, 0 otherwise.
{
	int ret=-1 ;
	char c ;
	cprintf("The angry %s glares at you menacingly...\n\r", MonTable[m].name) ;
	do
	{ cputs("Do what (Drink, Kick, Arrow, Combat, Blast, Fireball, Run, Help, Status) ? ") ;
	  c=toupper(getch()) ;
	  cprintf("%c\n\r",c) ;
	  switch(c)
	  { case 'S':	ShowStats() ;
			break ;
	    case 'D':	Drink() ;
			break ;
	    case 'B':	BlastCbt(m) ;
			break ;
	    case 'F':	FireCbt(m) ;
			break ;
	    case 'K':	KickCbt(m) ;
			break ;
	    case 'R':	if(RunCbt(m))
			  ret=2 ;
			break ;
	    case 'C':	Cbt(m,0) ;
			break ;
	    case 'H':	cprintf("The %s has %d hp\n\r", MonTable[m].name, mhp) ;
			break ;
	    case 'A':	ArrowCbt() ;
			break ;
	    case 0:	getch() ;	// foobar put in Help
	    default:    putch(7) ;
			break ;
	  }
	  if(ret<0&&mhp>0&&hp>0&&(!random(6)))
	  { cputs("Enraged, it leaps upon you!\n\r") ;
	    Cbt(m,1) ;
	  }
	  if(mhp<=0)
	  { cprintf("\n\rThe vile creature lies dead on the floor!\n\r",MonTable[m].name) ;
	    killed++ ;
	    ret=1 ;
	  }
	  else
	    if(MonTable[m].flag&2)	// regenerate
	      mhp+=sqrt(mxhp-mhp)/2 ;
	  if(hp<0)
	    ret=0 ;
	} while(ret<0) ;
	return ret ;
}

// TREASURE -----------------------------------------------

void Treasure(int m)
{
	long cash, magic, c2, f=0 ;
	int g[7], i, a=0, b ;
	if(m>=0)
	{ a=cash=MonTable[m].ct ;
	  a+=magic=MonTable[m].mt ;
	}
	if(!a)
	{ cash=random(1000)*random(3) ;
	  magic=random(5)*random(6)*random(2) ;
	  if(m>=0&&random(3))
	    cash*=max(MonTable[m].hp/10,1) ;
	}
	cash=cash*(long)random(1000)/500 ;
	if(cash>32767)
	  cash=32767 ;
	magic=magic*(long)random(1000)/500 ;
	cputs("\n\rYou open the chest...") ; delay(600) ;
	cputs("to find ") ;

	do
	{ if(random(10)<magic&&random(2))
	  { f=2 ;
	    switch(random(13))
	    { case 0:	cputs("a suit of armour, ") ;
			hp+=dran(30)+30 ;
			break ;
	      case 1:	cputs("a sword, ") ;
			hp+=dran(20)+20 ;
			break ;
	      case 2:	cputs("a spear, ") ;
			hp+=dran(10)+10 ;
			break ;
	      case 3:	cputs("a scroll, ") ;
			spell+=dran(4)+1 ;
			fball+=random(3) ;
			break ;
	      case 4:	cputs("a book, ") ;
			spell+=dran(6) ;
			hp+=random(2)*dran(25) ;
			fball+=random(3) ;
			break ;
	      case 5:	cputs("a wand, ") ;
			if(random(2))
			  spell+=dran(3)+4 ;
			else
			  fball+=random(3)+2 ;
			break ;
	      case 6:	cputs("a ring, ") ;
			spell+=dran(6) ;
			hp+=random(3)*dran(15) ;
			break ;
	      case 7:	cputs("a potion, ") ;
			pots++ ;
			break ;
	      case 8:	cputs("some arrows, ") ;
			arrow+=dran(6)+3 ;
			break ;
	      case 9:	cputs("a dagger, ") ;
			hp+=dran(5)+5 ;
			break ;
	      case 10:	i=random(3)+2 ;
			cprintf("a ring of %d keys, ",i) ;
			while(i--)
			  key|=1<<random(16) ;
			break ;
	      case 11:
	      case 12:	cputs("a key, ") ;
			key|=1<<random(16) ;
			break ;
	    }
	    cash++ ;
	  }
	  magic-=5 ;
	}
	while(magic>0) ;

	for(i=0;i<7;i++)
	  g[i]=0 ;

	c2=cash ;
	while(c2>0)
	{ a=random(7) ;
	  b=random(7) ;
	  a=min(a,b)+1 ;
	  if(random(2))
	    g[a-1]++ ;
	  c2-=random(80*a*a) ;
	}

	for(i=6;i>=0;i--)
	{ if(g[i])
	  { cprintf("%d %s%s, ",g[i],gemname[i],g[i]>1?"s":"") ;
	    gems[i]+=g[i] ;
	  }
	}

	if(cash)
	{ i=random(cash/30) ; if(i) { cprintf("%d pp, ",i) ; pp+=i ; }
	  i=random(cash/10) ; if(i) { cprintf("%d gp, ",i) ; gp+=i ; }
	  i=random(cash/3)+1 ; cprintf("%d sp and ",i) ; sp+=i ;
	  i=random(cash)+1 ; cprintf("%d cp!\n\r",i) ; cp+=i ;
	  f=1 ;
	}

	if(!f)
	  cputs("nothing but dust.\n\r") ;
}

// DO THE STUFF -------------------------------------------


void Trap()
{        // foobar
}

void Wanderer(int p)
{
	int m ;
	if(!random(p))
	{ m=random(nmon) ;
	  cprintf("\n\rBeware! You are assailed by a wandering %s!\n\r", MonTable[m].name) ;
	  mhp=MonTable[m].hp*(50+dran(50))/100 ;
	  mxhp=mhp=max(mhp,1) ;
	  Combat(m) ;
	}
}

void MakeRooms()
{
	int n, i ;
	for(n=0;n<3;n++)
	{ i=random(8) ;
	  if(i==2||i==3)	// remove some stairs
	    i=random(8) ;
	  Room[n].wall=i ;
	  i=random(30)-14 ;
	  Room[n].key=max(i,0) ;
	  Room[n].contain=random(4) ;
	  Room[n].mon=random(nmon) ;
	  i=AdjSize[Room[n].adj=random(MAXADJ)] ;
	  i=MonTable[Room[n].mon].hp*(i+dran(i))/100 ;
	  Room[n].mhp=Room[n].mxhp=max(i,1) ;
	}
}

void Pit()
{
	int m=random(nmon), a=random(MAXADJ) ;
	mhp=MonTable[m].hp*(AdjSize[a]+dran(AdjSize[a]))/100 ;
	mxhp=mhp=max(mhp,1) ;
	cputs("You fall into a ") ;
	do
	{ lvl++ ;
	  hp-=5+random(10) ;
	  cputs("deep ") ;
	} while(!random(4)) ;
	cputs("pit!\n\r") ;
	if(random(2))
	{ cputs("At the bottom is a") ;
	  switch(random(6))
	  { case 0:	cputs(" mass of spikes!\n\r") ;
			hp-=random(15) ;
			break ;
	    case 1:	cputs(" pool of acid!\n\r") ;
			hp-=dran(5) ;
			break ;
	    case 2:	cprintf("%s %s!\n\r",AdjList[a],MonTable[m].name) ;
			Combat(m) ;
			break ;
	    case 3:	cprintf("%s %s and a chest!\n\r",AdjList[a],MonTable[m].name) ;
			if(hp>0&&Combat(m)==1)
			  Treasure(m) ;
			break ;
	    case 4:	cputs(" Treasure Chest!\n\r") ;
			Treasure(-1) ;
			break ;
	    case 5:     if(random(2))
			{ lvl-- ;
			  cputs(" long") ;
			}
			cputs(" ladder!\n\r") ;
			lvl-- ;
			break ;
	  }
	}
	if(hp==0)
	  hp=1 ;
	Wanderer(20) ;
}

void ShowRooms()
{
	int n ;
	CR ;
	for(n=0;n<3;n++)
	{ gotoxy(1+n*26,wherey()) ;
	  cputs(RoomName[Room[n].wall]) ;
	}
	cputs("\n\n\rWhere will you go? ") ;
}

int ChooseRoom()
{
	int dir=-1 ;
	while(dir==-1)
	{ ShowRooms() ;
	  switch(toupper(getch()))
	  { case 27:	quit=1 ;
			dir=-2 ;
			break ;
	    case 'D':	Drink() ;
			break ;
	    case 'S':	ShowStats() ;
			break ;
	    case 0: 	switch(getch())
			{ case Lkey:	dir=0 ;
					cputs("Left\n\r") ;
					break ;
			  case Ukey:	dir=1 ;
					cputs("Ahead\n\r") ;
					break ;
			  case Rkey:	dir=2 ;
					cputs("Right\n\r") ;
					break ;
			  default:	putch(7) ;
					break ;
			}
			break ;
	    default:	putch(7) ;
			break ;
	  }
	}
	return dir ;
}

void DoWall(int n)
{
	cputs("\n\rYou crash into the wall...") ;
	if(!random(4))
	{ cputs("which collapses!") ;
	  Room[n].wall=random(2)+6 ;	// open door
	}
	hp-=5+random(10) ;
	if(hp<1)
	  hp=1 ;
	Wanderer(10) ;
}

void DoPassage()
{
	cputs("You walk down the passage...") ;
	if(!random(10))
	  Trap() ;
	else
	  CR ;
	Wanderer(20) ;
}

void ShowContain(int n)
{
	cprintf("The %s contains ",RoomName[Room[n].wall]) ;
	switch(Room[n].contain)
	{ case 0:	cputs("nothing of note.") ;
			break ;
	  case 1:	cprintf("a%s %s!",AdjList[Room[n].adj],MonTable[Room[n].mon].name) ;
			break ;
	  case 2:	cputs("a Treasure Chest!") ;
			break ;
	  case 3:	cprintf("a%s %s and a Treasure Chest!",AdjList[Room[n].adj],MonTable[Room[n].mon].name) ;
			break ;
	}
	CR ;
}

int AskEnter(int n)
{
	int ret=-1, c, m=Room[n].mon ;
	do
	{ cputs("Will you enter (Y/N/S/H/D)? ") ;
	  c=toupper(getch()) ;
	  cprintf("%c\n\r",c) ;
	  switch(c)
	  { case 'Y':	ret=1 ;
			break ;
	    case 'S':	ShowStats() ;
			break ;
	    case 'D':	Drink() ;
			break ;
	    case 'N':	ret=0 ;
			break ;
	    case 'H':   if(Room[n].contain&1)
			  cprintf("A typical %s has %d hp\n\r", MonTable[m].name, MonTable[m].hp) ;
			else
			  cprintf("What?\n\r") ;
			break ;
	    case 0:	getch() ;
	    default:	putch(7) ;
			break ;
	  }
	} while(ret==-1) ;
	return ret ;
}

int DoCave(int n)
{
	int ret=0 ;
	ShowContain(n) ;
	if(AskEnter(n))
	{ mhp=Room[n].mhp ;
	  mxhp=Room[n].mxhp ;
	  switch(Room[n].contain)
	  { case 2:	Treasure(-1) ;
	    case 0:	ret=1 ;
			break ;
	    case 1:	ret=Combat(Room[n].mon) ;
			break ;
	    case 3:	ret=Combat(Room[n].mon) ;
			if(ret==1&&hp>0)
			  Treasure(Room[n].mon) ;
			break ;
	  }
	  Room[n].mhp=mhp ;
	}
	if(ret)
	  Wanderer(30) ;

	return ret ;
}

int OpenDoor(int n)
{
	    Room[n].wall=random(2)+6 ;
	    return DoCave(n) ;
}

int BlastDoor()
{
	int ret=0 ;
	if(spell)
	{ spell-- ;
	  cputs("BLAM!!   You blast the door.\n\r") ;
	  if(random(2))
	  { ret=1 ;
	    cputs("It falls open in a cloud of dust.\n\r") ;
	  }
	  else
	    cputs("It shudders, but still stands.\n\r") ;
	}
	else
	  cputs("\n\rYou have no spells.\n\r") ;
	return ret ;
}

int FireDoor()
{
	int ret=0 ;
	if(fball)
	{ fball-- ;
	  cputs("KaThoom!!!!   You blast the door to smoking ashes!\n\r") ;
	  ret=1 ;
	}
	else
	  cputs("\n\rYou have no fireballs.\n\r") ;
	return ret ;
}

int KickDoor()
{
	int ret=0 ;
	cputs("Wham!   You hoof the door!\n\r") ;
	if(random(hp)>random(100))
	{ ret=1 ;
	  cputs("It crashes off its hinges!\n\r") ;
	}
	else
	  cputs("No effect.\n\r") ;
	hp-=5+random(10) ;
	if(hp<1)
	  hp=1 ;
	return ret ;
}

int DoorAction(int n)
{
	int ret=2, c ;
	do
	{ cputs("Do What (Status, Drink, Listen, Kick, Blast, Fireball, Nowt)? ") ;
	  c=toupper(getch()) ;
	  cprintf("%c\n\r",c) ;
	  switch(c)
	  { case 'S':	ShowStats() ;
			break ;
	    case 'B':	if(BlastDoor())
			  ret=OpenDoor(n)?1:0 ;
			break ;
	    case 'F':	if(FireDoor())
			  ret=OpenDoor(n)?1:0 ;
			break ;
	    case 'K':	if(KickDoor())
			  ret=OpenDoor(n)?1:0 ;
			break ;
	    case 'L':	// foobar listen
	    case 'N':	ret=0 ;
			break ;
	    case 'D':	Drink() ;
			break ;
	    case 0:	getch() ;	// foobar put in Help
	    default:    putch(7) ;
			break ;
	  }
	} while(ret==2) ;
	return ret ;
}

int DoDoor(int n)
{
	int ret ;
	cputs("You try the handle...") ;
	delay(600) ;
	if(Room[n].key)
	{ cputs("but the door is locked.\n\r") ;
	  if((key>>Room[n].key)&1)
	  { cputs("However, you have the key!\n\r") ;
	    ret=OpenDoor(n) ;
	  }
	  else
	    ret=DoorAction(n) ;
	}
	else
	{ cputs("and the door opens.\n\r") ;
	  ret=OpenDoor(n) ;
	}
	return ret ;
}

void Escape()
{
	cputs("You emerge blinking into the sunshine! You have escaped!!\n\r") ;
	lvl=-10 ;
	ShowStats() ;
	quit=1 ;
}

void NextRoom()
{
	int n, done ;
	CR ;
	for(n=0;n<80;n++)
	  putch('-') ;
	MakeRooms() ;
	if(Room[0].wall|Room[1].wall|Room[2].wall)
	{ do
	  { n=ChooseRoom() ;
	    if(n>-1)
	    { switch(Room[n].wall)
	      { case 0:	done=0 ;
			DoWall(n) ;
			break ;
		case 1:	DoPassage() ;
			done=1 ;
			break ;
		case 2:	lvl-- ;
			if(random(10)<-lvl)
			  Escape() ;
			done=1 ;
			break ;
		case 3:	lvl++ ;
			done=1 ;
			break ;
		case 4:
		case 5:	done=DoDoor(n) ;
			break ;
		case 6:
		case 7:	done=DoCave(n) ;
			break ;
	      }
	    }
	    else
	      done=1 ;
	    if(!done&&hp>0)
	      Wanderer(30) ;
	  } while(!done&&hp>0) ;
	}
	else
	  Pit() ;
}

void Death()
{
	int i ;
	cputs("\n\n\rOh Dear. You're dead...\n\r") ;
	ShowStats() ;
	cputs("\nHit a key...") ;
	if(!getch())
	  getch() ;
	quit=1 ;
}

// MAIN ---------------------------------------------------

void main()
{
	if(Init())
	{ do
	  { NextRoom() ;
	    if(hp<0)
	      Death() ;
	  } while(!quit) ;
	}
	CR ;
}

/* STUFF TO DO --------------------------------------------
Trap()
Intro text
Help
Toothbrushes etc
Listen
File handling
Walls & fireballs, spells, etc.
*/